set NB_TEST=10
set F=config.h
move /y %F% config-prev.h
goto start

:create_file
echo #if !defined _WIN64 ^&^& !defined __AVX__>%F%
echo #define AES_ENC_OPTI "-O%1">>%F%
echo #define AES_DEC_OPTI "-O%1">>%F%
echo #define SERPENT_ENC_OPTI "-O%1">>%F%
echo #define SERPENT_DEC_OPTI "-O%1">>%F%
echo #define SHACAL2_ENC_OPTI "-O%1">>%F%
echo #define SHACAL2_DEC_OPTI "-O%1">>%F%
echo #endif>>%F%
echo #if !defined _WIN64 ^&^& defined __AVX__>>%F%
echo #define AES_ENC_OPTI "-O%1">>%F%
echo #define AES_DEC_OPTI "-O%1">>%F%
echo #define SERPENT_ENC_OPTI "-O%1">>%F%
echo #define SERPENT_DEC_OPTI "-O%1">>%F%
echo #define SHACAL2_ENC_OPTI "-O%1">>%F%
echo #define SHACAL2_DEC_OPTI "-O%1">>%F%
echo #endif>>%F%
echo #if defined _WIN64 ^&^& !defined __AVX__>>%F%
echo #define AES_ENC_OPTI "-O%1">>%F%
echo #define AES_DEC_OPTI "-O%1">>%F%
echo #define SERPENT_ENC_OPTI "-O%1">>%F%
echo #define SERPENT_DEC_OPTI "-O%1">>%F%
echo #define SHACAL2_ENC_OPTI "-O%1">>%F%
echo #define SHACAL2_DEC_OPTI "-O%1">>%F%
echo #endif>>%F%
echo #if defined _WIN64 ^&^& defined __AVX__>>%F%
echo #define AES_ENC_OPTI "-O%1">>%F%
echo #define AES_DEC_OPTI "-O%1">>%F%
echo #define SERPENT_ENC_OPTI "-O%1">>%F%
echo #define SERPENT_DEC_OPTI "-O%1">>%F%
echo #define SHACAL2_ENC_OPTI "-O%1">>%F%
echo #define SHACAL2_DEC_OPTI "-O%1">>%F%
echo #endif>>%F%
goto :eof

:start
:: ----------------------------------------------------------------------
call :create_file 1

call comp32.bat -
for /l %%N in (1,1,%NB_TEST%) do (
for /f "tokens=2,3" %%I in ('ProxyCrypt32 -bm 1 -noaesni ^| find "AES"') do (
set /a aes_enc32_1+=%%I
set /a aes_dec32_1+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt32 -bm 2 ^| find "Serpent"') do (
set /a serpent_enc32_1+=%%I
set /a serpent_dec32_1+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt32 -bm 3 ^| find "SHACAL-2"') do (
set /a shacal2_enc32_1+=%%I
set /a shacal2_dec32_1+=%%J
)
)
call comp64.bat -
for /l %%N in (1,1,%NB_TEST%) do (
for /f "tokens=2,3" %%I in ('ProxyCrypt64 -bm 1 -noaesni ^| find "AES"') do (
set /a aes_enc64_1+=%%I
set /a aes_dec64_1+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt64 -bm 2 ^| find "Serpent"') do (
set /a serpent_enc64_1+=%%I
set /a serpent_dec64_1+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt64 -bm 3 ^| find "SHACAL-2"') do (
set /a shacal2_enc64_1+=%%I
set /a shacal2_dec64_1+=%%J
)
)
call comp32avx.bat -
for /l %%N in (1,1,%NB_TEST%) do (
for /f "tokens=2,3" %%I in ('ProxyCrypt32avx -bm 1 -noaesni ^| find "AES"') do (
set /a aes_enc32avx_1+=%%I
set /a aes_dec32avx_1+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt32avx -bm 2 ^| find "Serpent"') do (
set /a serpent_enc32avx_1+=%%I
set /a serpent_dec32avx_1+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt32avx -bm 3 ^| find "SHACAL-2"') do (
set /a shacal2_enc32avx_1+=%%I
set /a shacal2_dec32avx_1+=%%J
)
)
call comp64avx.bat -
for /l %%N in (1,1,%NB_TEST%) do (
for /f "tokens=2,3" %%I in ('ProxyCrypt64avx -bm 1 -noaesni ^| find "AES"') do (
set /a aes_enc64avx_1+=%%I
set /a aes_dec64avx_1+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt64avx -bm 2 ^| find "Serpent"') do (
set /a serpent_enc64avx_1+=%%I
set /a serpent_dec64avx_1+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt64avx -bm 3 ^| find "SHACAL-2"') do (
set /a shacal2_enc64avx_1+=%%I
set /a shacal2_dec64avx_1+=%%J
)
)

:: ----------------------------------------------------------------------
call :create_file 2

call comp32.bat -
for /l %%N in (1,1,%NB_TEST%) do (
for /f "tokens=2,3" %%I in ('ProxyCrypt32 -bm 1 -noaesni ^| find "AES"') do (
set /a aes_enc32_2+=%%I
set /a aes_dec32_2+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt32 -bm 2 ^| find "Serpent"') do (
set /a serpent_enc32_2+=%%I
set /a serpent_dec32_2+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt32 -bm 3 ^| find "SHACAL-2"') do (
set /a shacal2_enc32_2+=%%I
set /a shacal2_dec32_2+=%%J
)
)
call comp64.bat -
for /l %%N in (1,1,%NB_TEST%) do (
for /f "tokens=2,3" %%I in ('ProxyCrypt64 -bm 1 -noaesni ^| find "AES"') do (
set /a aes_enc64_2+=%%I
set /a aes_dec64_2+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt64 -bm 2 ^| find "Serpent"') do (
set /a serpent_enc64_2+=%%I
set /a serpent_dec64_2+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt64 -bm 3 ^| find "SHACAL-2"') do (
set /a shacal2_enc64_2+=%%I
set /a shacal2_dec64_2+=%%J
)
)
call comp32avx.bat -
for /l %%N in (1,1,%NB_TEST%) do (
for /f "tokens=2,3" %%I in ('ProxyCrypt32avx -bm 1 -noaesni ^| find "AES"') do (
set /a aes_enc32avx_2+=%%I
set /a aes_dec32avx_2+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt32avx -bm 2 ^| find "Serpent"') do (
set /a serpent_enc32avx_2+=%%I
set /a serpent_dec32avx_2+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt32avx -bm 3 ^| find "SHACAL-2"') do (
set /a shacal2_enc32avx_2+=%%I
set /a shacal2_dec32avx_2+=%%J
)
)
call comp64avx.bat -
for /l %%N in (1,1,%NB_TEST%) do (
for /f "tokens=2,3" %%I in ('ProxyCrypt64avx -bm 1 -noaesni ^| find "AES"') do (
set /a aes_enc64avx_2+=%%I
set /a aes_dec64avx_2+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt64avx -bm 2 ^| find "Serpent"') do (
set /a serpent_enc64avx_2+=%%I
set /a serpent_dec64avx_2+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt64avx -bm 3 ^| find "SHACAL-2"') do (
set /a shacal2_enc64avx_2+=%%I
set /a shacal2_dec64avx_2+=%%J
)
)

:: ----------------------------------------------------------------------
call :create_file 3

call comp32.bat -
for /l %%N in (1,1,%NB_TEST%) do (
for /f "tokens=2,3" %%I in ('ProxyCrypt32 -bm 1 -noaesni ^| find "AES"') do (
set /a aes_enc32_3+=%%I
set /a aes_dec32_3+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt32 -bm 2 ^| find "Serpent"') do (
set /a serpent_enc32_3+=%%I
set /a serpent_dec32_3+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt32 -bm 3 ^| find "SHACAL-2"') do (
set /a shacal2_enc32_3+=%%I
set /a shacal2_dec32_3+=%%J
)
)
call comp64.bat -
for /l %%N in (1,1,%NB_TEST%) do (
for /f "tokens=2,3" %%I in ('ProxyCrypt64 -bm 1 -noaesni ^| find "AES"') do (
set /a aes_enc64_3+=%%I
set /a aes_dec64_3+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt64 -bm 2 ^| find "Serpent"') do (
set /a serpent_enc64_3+=%%I
set /a serpent_dec64_3+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt64 -bm 3 ^| find "SHACAL-2"') do (
set /a shacal2_enc64_3+=%%I
set /a shacal2_dec64_3+=%%J
)
)
call comp32avx.bat -
for /l %%N in (1,1,%NB_TEST%) do (
for /f "tokens=2,3" %%I in ('ProxyCrypt32avx -bm 1 -noaesni ^| find "AES"') do (
set /a aes_enc32avx_3+=%%I
set /a aes_dec32avx_3+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt32avx -bm 2 ^| find "Serpent"') do (
set /a serpent_enc32avx_3+=%%I
set /a serpent_dec32avx_3+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt32avx -bm 3 ^| find "SHACAL-2"') do (
set /a shacal2_enc32avx_3+=%%I
set /a shacal2_dec32avx_3+=%%J
)
)
call comp64avx.bat -
for /l %%N in (1,1,%NB_TEST%) do (
for /f "tokens=2,3" %%I in ('ProxyCrypt64avx -bm 1 -noaesni ^| find "AES"') do (
set /a aes_enc64avx_3+=%%I
set /a aes_dec64avx_3+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt64avx -bm 2 ^| find "Serpent"') do (
set /a serpent_enc64avx_3+=%%I
set /a serpent_dec64avx_3+=%%J
)
for /f "tokens=2,3" %%I in ('ProxyCrypt64avx -bm 3 ^| find "SHACAL-2"') do (
set /a shacal2_enc64avx_3+=%%I
set /a shacal2_dec64avx_3+=%%J
)
)

:: ----------------------------------------------------------------------
echo #if !defined _WIN64 ^&^& !defined __AVX__>%F%
set N=1
if %aes_enc32_2% gtr %aes_enc32_1% set N=2
if %aes_enc32_3% gtr %aes_enc32_2% if %aes_enc32_3% gtr %aes_enc32_1% set N=3
echo #define AES_ENC_OPTI "-O%N%">>%F%
set N=1
if %aes_dec32_2% gtr %aes_dec32_1% set N=2
if %aes_dec32_3% gtr %aes_dec32_2% if %aes_dec32_3% gtr %aes_dec32_1% set N=3
echo #define AES_DEC_OPTI "-O%N%">>%F%
set N=1
if %serpent_enc32_2% gtr %serpent_enc32_1% set N=2
if %serpent_enc32_3% gtr %serpent_enc32_2% if %serpent_enc32_3% gtr %serpent_enc32_1% set N=3
echo #define SERPENT_ENC_OPTI "-O%N%">>%F%
set N=1
if %serpent_dec32_2% gtr %serpent_dec32_1% set N=2
if %serpent_dec32_3% gtr %serpent_dec32_2% if %serpent_dec32_3% gtr %serpent_dec32_1% set N=3
echo #define SERPENT_DEC_OPTI "-O%N%">>%F%
set N=1
if %shacal2_enc32_2% gtr %shacal2_enc32_1% set N=2
if %shacal2_enc32_3% gtr %shacal2_enc32_2% if %shacal2_enc32_3% gtr %shacal2_enc32_1% set N=3
echo #define SHACAL2_ENC_OPTI "-O%N%">>%F%
set N=1
if %shacal2_dec32_2% gtr %shacal2_dec32_1% set N=2
if %shacal2_dec32_3% gtr %shacal2_dec32_2% if %shacal2_dec32_3% gtr %shacal2_dec32_1% set N=3
echo #define SHACAL2_DEC_OPTI "-O%N%">>%F%
echo #endif>>%F%

echo #if !defined _WIN64 ^&^& defined __AVX__>>%F%
set N=1
if %aes_enc32avx_2% gtr %aes_enc32avx_1% set N=2
if %aes_enc32avx_3% gtr %aes_enc32avx_2% if %aes_enc32avx_3% gtr %aes_enc32avx_1% set N=3
echo #define AES_ENC_OPTI "-O%N%">>%F%
set N=1
if %aes_dec32avx_2% gtr %aes_dec32avx_1% set N=2
if %aes_dec32avx_3% gtr %aes_dec32avx_2% if %aes_dec32avx_3% gtr %aes_dec32avx_1% set N=3
echo #define AES_DEC_OPTI "-O%N%">>%F%
set N=1
if %serpent_enc32avx_2% gtr %serpent_enc32avx_1% set N=2
if %serpent_enc32avx_3% gtr %serpent_enc32avx_2% if %serpent_enc32avx_3% gtr %serpent_enc32avx_1% set N=3
echo #define SERPENT_ENC_OPTI "-O%N%">>%F%
set N=1
if %serpent_dec32avx_2% gtr %serpent_dec32avx_1% set N=2
if %serpent_dec32avx_3% gtr %serpent_dec32avx_2% if %serpent_dec32avx_3% gtr %serpent_dec32avx_1% set N=3
echo #define SERPENT_DEC_OPTI "-O%N%">>%F%
set N=1
if %shacal2_enc32avx_2% gtr %shacal2_enc32avx_1% set N=2
if %shacal2_enc32avx_3% gtr %shacal2_enc32avx_2% if %shacal2_enc32avx_3% gtr %shacal2_enc32avx_1% set N=3
echo #define SHACAL2_ENC_OPTI "-O%N%">>%F%
set N=1
if %shacal2_dec32avx_2% gtr %shacal2_dec32avx_1% set N=2
if %shacal2_dec32avx_3% gtr %shacal2_dec32avx_2% if %shacal2_dec32avx_3% gtr %shacal2_dec32avx_1% set N=3
echo #define SHACAL2_DEC_OPTI "-O%N%">>%F%
echo #endif>>%F%

echo #if defined _WIN64 ^&^& !defined __AVX__>>%F%
set N=1
if %aes_enc64_2% gtr %aes_enc64_1% set N=2
if %aes_enc64_3% gtr %aes_enc64_2% if %aes_enc64_3% gtr %aes_enc64_1% set N=3
echo #define AES_ENC_OPTI "-O%N%">>%F%
set N=1
if %aes_dec64_2% gtr %aes_dec64_1% set N=2
if %aes_dec64_3% gtr %aes_dec64_2% if %aes_dec64_3% gtr %aes_dec64_1% set N=3
echo #define AES_DEC_OPTI "-O%N%">>%F%
set N=1
if %serpent_enc64_2% gtr %serpent_enc64_1% set N=2
if %serpent_enc64_3% gtr %serpent_enc64_2% if %serpent_enc64_3% gtr %serpent_enc64_1% set N=3
echo #define SERPENT_ENC_OPTI "-O%N%">>%F%
set N=1
if %serpent_dec64_2% gtr %serpent_dec64_1% set N=2
if %serpent_dec64_3% gtr %serpent_dec64_2% if %serpent_dec64_3% gtr %serpent_dec64_1% set N=3
echo #define SERPENT_DEC_OPTI "-O%N%">>%F%
set N=1
if %shacal2_enc64_2% gtr %shacal2_enc64_1% set N=2
if %shacal2_enc64_3% gtr %shacal2_enc64_2% if %shacal2_enc64_3% gtr %shacal2_enc64_1% set N=3
echo #define SHACAL2_ENC_OPTI "-O%N%">>%F%
set N=1
if %shacal2_dec64_2% gtr %shacal2_dec64_1% set N=2
if %shacal2_dec64_3% gtr %shacal2_dec64_2% if %shacal2_dec64_3% gtr %shacal2_dec64_1% set N=3
echo #define SHACAL2_DEC_OPTI "-O%N%">>%F%
echo #endif>>%F%

echo #if defined _WIN64 ^&^& defined __AVX__>>%F%
set N=1
if %aes_enc64avx_2% gtr %aes_enc64avx_1% set N=2
if %aes_enc64avx_3% gtr %aes_enc64avx_2% if %aes_enc64avx_3% gtr %aes_enc64avx_1% set N=3
echo #define AES_ENC_OPTI "-O%N%">>%F%
set N=1
if %aes_dec64avx_2% gtr %aes_dec64avx_1% set N=2
if %aes_dec64avx_3% gtr %aes_dec64avx_2% if %aes_dec64avx_3% gtr %aes_dec64avx_1% set N=3
echo #define AES_DEC_OPTI "-O%N%">>%F%
set N=1
if %serpent_enc64avx_2% gtr %serpent_enc64avx_1% set N=2
if %serpent_enc64avx_3% gtr %serpent_enc64avx_2% if %serpent_enc64avx_3% gtr %serpent_enc64avx_1% set N=3
echo #define SERPENT_ENC_OPTI "-O%N%">>%F%
set N=1
if %serpent_dec64avx_2% gtr %serpent_dec64avx_1% set N=2
if %serpent_dec64avx_3% gtr %serpent_dec64avx_2% if %serpent_dec64avx_3% gtr %serpent_dec64avx_1% set N=3
echo #define SERPENT_DEC_OPTI "-O%N%">>%F%
set N=1
if %shacal2_enc64avx_2% gtr %shacal2_enc64avx_1% set N=2
if %shacal2_enc64avx_3% gtr %shacal2_enc64avx_2% if %shacal2_enc64avx_3% gtr %shacal2_enc64avx_1% set N=3
echo #define SHACAL2_ENC_OPTI "-O%N%">>%F%
set N=1
if %shacal2_dec64avx_2% gtr %shacal2_dec64avx_1% set N=2
if %shacal2_dec64avx_3% gtr %shacal2_dec64avx_2% if %shacal2_dec64avx_3% gtr %shacal2_dec64avx_1% set N=3
echo #define SHACAL2_DEC_OPTI "-O%N%">>%F%
echo #endif>>%F%

call comp32.bat -
call comp64.bat -
call comp32avx.bat -
call comp64avx.bat -

pause